﻿//長辺を nSizeへリサイズ　それ以下の画像は無視する
function ImageResize(nSize)
{
    w = activeDocument.width.value;
    h = activeDocument.height.value;
    //alert(w + " , " + h);
    if (w > h) {
        nh = h / w * nSize;
        nw = nSize;
    } else {
        nw = w / h * nSize;
        nh = nSize;
    }

    if ((w > nSize) || (h > nSize)) {
        activeDocument.resizeImage(nw, nh, 72, ResampleMethod.BICUBICSHARPER);
    } else {
        activeDocument.resizeImage(w, h, 72, ResampleMethod.BICUBICSHARPER);
    }
}


// Exif出力
function WriteExifStringToDoc(AExif, r, g, b, ATrans)
{
    docObj = activeDocument;
    layObj = docObj.artLayers.add();
    layObj.kind = LayerKind.TEXT;
    layObj.textItem.font = "Century";        //　フォント指定
    layObj.textItem.color.rgb.red = r;      //　フォントカラー
    layObj.textItem.color.rgb.green = g;    //　フォントカラー
    layObj.textItem.color.rgb.blue = b;     //　フォントカラー
    layObj.textItem.size = 12;              //　フォントサイズ
    layObj.textItem.justification = Justification.RIGHT; //　行揃え指定
    layObj.textItem.antiAliasMethod = AntiAlias.SHARP;    //アンチエイリアスの種類
    layObj.textItem.contents = AExif;
    w = parseFloat(docObj.width);           //　ページの横幅
    h = parseFloat(docObj.height);          //　ページの縦幅
    x = parseFloat(layObj.bounds[2]);       //　テキストの右座標
    y = parseFloat(layObj.bounds[3]);       //　テキストの下座標
    offsetX = 10;                           //　右側の余白
    offsetY = 6;                            //　下側の余白
    layObj.translate(w - x - offsetX, h - y - offsetY);
    layObj.opacity = ATrans;                // 不透明度を設定
}

// Exifデータの取得
function GetExifData()
{
    docObj = activeDocument;
    exif = docObj.info.exif;
    aMax = exif.length;
    ISO = "";
    Focul = "";
    TV = "";
    AV = "";
    Bias = "";
    PicInfo = "";

    // Exifが格納されている配列から必要なデータを取得する
    for (i=0; i<=aMax -1; i++)
    {
        if (exif[i][2] == 37386) { Focul = exif[i][1] }
        if (exif[i][2] == 37378) { if (AV == "") { AV = exif[i][1] } } 
        if (exif[i][2] == 33437) { if (AV == "") { AV = exif[i][1] } }
        if (exif[i][2] == 37377) { if (TV == "") { TV = exif[i][1] } }
        if (exif[i][2] == 33434) { if (TV == "") { TV = exif[i][1] } }
        if (exif[i][2] == 37380) { if (Bias == "") { Bias = exif[i][1] } }
        if (exif[i][2] == 34855) { ISO = "ISO" + exif[i][1] }
    } 

    Focul = Focul.replace(".0 ", "");   // 小数点以下まで表示してくれやがるので、整数へ整える
    AV = AV.replace("f/", "F");         // LRからのExifデータは f/2.8 などと取得されるため、一般的な表記へ変更
    TV = TV.replace(" sec", "");        // secの文字を取る
    fB = Bias;
    //露出補正値の整形
    if (fB == 0) { Bias = "±" + Bias + "EV" }
    if (fB > 0)  { Bias = "+" + Bias + "EV" }
    if (fB < 0)  { Bias = Bias + "EV" }

    Bias = Bias.replace("0EV", "EV");
    Bias = Bias.replace("±0.0EV", "±0EV");
    //以下文字を繋ぐ
//    PicInfo = PicInfo + "[  ";
    if (Focul.length > 0) { PicInfo = PicInfo + Focul + "  " }
    if (AV.length > 0) { PicInfo = PicInfo + AV + "  " }
    if (TV.length > 0) { PicInfo = PicInfo + TV + "  " }
    if (ISO.length > 0) { PicInfo = PicInfo + ISO + "  " }
    if (Bias.length > 0) { PicInfo = PicInfo + Bias + "  " }
   
//    PicInfo = PicInfo + "]";

    return PicInfo;
}


//実行のメイン Proc
preferences.rulerUnits = Units.PIXELS;

ImageResize(1024);
sExf = GetExifData();
WriteExifStringToDoc(sExf, 255, 255, 255, 80);
